!(function() {

    var model = BI.inherit(Fix.Model, {
        _init: function () {
            this.service = BI.Services.getService("dec.service.data.set");
        },
        state: function () {

            return {
                list:this.options.list,
                /*  paramHeader: function () {
                      //定义参数列表表头
                      var map = BI.map(BI.Constants.getConstant("dec.constants.data.set.sql.header"), function (i, v) {
                          return BI.extend({
                              textAlign: "left",
                              height: 30,
                              hgap: 10
                          }, v);
                      });
                      map.push({
                          textAlign: "left",
                          height: 30,
                          hgap: 10,
                          text: ""
                      });
                      return [map];
                  }(),*/
            };
        },
        computed: {

            listItems: function () {
                var self = this;

                return BI.map(this.model.list, function (i, config) {

                    return {
                        type: "bi.vertical_adapt",
                        cls: "bi-border",
                        items:[{
                            type: "bi.label",
                            value: config.customizeName,
                            textAlign: "left",
                            height: 30,
                            width: 200,
                            lgap: 10,

                        },{
                            type: "bi.icon_button",
                            cls: "default-delete-font",
                            height: 30,
                            lgap: 10,
                            title: BI.i18nText("Dec-Basic_Delete"),
                            handler: function () {
                                self.deleteItem(i);
                            }
                        }, {
                            type: "bi.icon_button",
                            cls: "normal-edit-font",
                            height: 30,
                            lgap: 10,
                            title: BI.i18nText("Dec-Basic_Edit"),
                            handler: function () {
                                var type = "addoredit" + BI.UUID();
                                step =  DecCst.factory.step[config.type].type;
                                debugger
                                console.log(config)
                                var pane = {
                                    type: "dec.factory.basic.popup",
                                    info: {
                                        name:config.customizeName,
                                        type:config.name,
                                        items: self.options.info.model[step + "Items"],
                                        config: config.text,
                                        parameters:config.parameters
                                    },
                                    cardType: "dec.factory.sub.config.editor",
                                    //groupId:o.groupId,
                                    onClickConfirm: function (val, callback) {
                                        if(null != val) {
                                            val.type = config.type;
                                            self.editItem(i, val);
                                            /*    self.options.info.subConfigs.advanceList.push(val);
                                                self.list.addItem({
                                                    type:"bi.label",
                                                    text: val.customizeName
                                                });*/
                                            //self.options.
                                            callback(true, null)
                                        }
                                        //var ids = self.table.getValue();
                                        //self.store.apiTransferGroup(ids, val, callback);
                                    },

                                    listeners: [
                                        {
                                            eventName: "EVENT_CLOSE",
                                            action: function () {
                                                BI.Popovers.remove(type);
                                            }
                                        }
                                    ]
                                };

                                BI.Popovers.create(type, {
                                    type: "bi.popover",
                                    header:  DecCst.factory.step[config.type].name,
                                    body: pane,
                                }).open(type);
                            }
                        }]
                    } ;
                });
            },
        },

        actions: {
            refreshParam: function (v) {
                var self = this;
                debugger
                Dec.Utils.getDataSetParameters({
                    datasetData:{
                        loaderConfig:self.model.config
                    },
                    datasetType:"factory",
                    datasetName:""
                }, function (res) {

                    self.model.parameters = self.service.getParameters(res.data, self.model.parameters);
                });
            },
            addParamter:function(v){
                this.model.parameters.push(v);
            },
            deleteParameter:function(index){
                this.model.parameters.splice(index, 1);
            },
            deleteItem:function(index){
                this.model.list.splice(index, 1);
            },
            editItem:function(index, v){
                this.model.list[index] = v;
            },
            _getConfig:function(value, items){
                for (let i = 0; i < items.length; i++) {
                    if(value === items[i].value) {
                        return items[i].dftConfig;
                    }
                }
                return "{}"
            },

        }
    });
    BI.model("dec.model.factory.widget.advance", model);
})()